#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}

#define int long long
const int N = 5e3, INF = 2e18, K = 2000;
const int MOD = 1e9;
bool p[N][N];
void solve() {
    int k, n;
    cin >> k >> n;

    vector<string> opvec(n);
    vector<int> avec(n);
    bool podzadacha = true;
    for (int i = 0; i < n; i++) {
        cin >> opvec[i] >> avec[i];
        if (avec[i] != k) {
            podzadacha = false;
        }
    }
    if (!podzadacha) {
        int lx = K, ly = K;
        int ans = 0;
        for (int y = ly; y < ly + k; y++) {
            for (int x = lx; x < lx + k; x++) {
                p[y][x] = true;
                ans++;
            }
        }
        for (int i = 0; i < n; i++) {
            string op;
            int a;
            op = opvec[i];
            a = avec[i];
            if (op == "E") {
                for (int y = ly; y < ly + k; y++) {
                    for (int x = lx + k; x < lx + k + a; x++) {
                        if (!p[y][x]) {
                            p[y][x] = true;
                            ans++;
                        }
                    }
                }
                lx += a;
            } else if (op == "W") {
                for (int y = ly; y < ly + k; y++) {
                    for (int x = lx; x >= lx - a; x--) {
                        if (!p[y][x]) {
                            p[y][x] = true;
                            ans++;
                        }
                    }
                }
                lx -= a;
            } else if (op == "N") {
                for (int y = ly + k; y < ly + k + a; y++) {
                    for (int x = lx; x < lx + k; x++) {
                        if (!p[y][x]) {
                            p[y][x] = true;
                            ans++;
                        }
                    }
                }
                ly += a;
            } else if (op == "S") {
                for (int y = ly; y >= ly - a; y--) {
                    for (int x = lx; x < lx + k; x++) {
                        if (!p[y][x]) {
                            p[y][x] = true;
                            ans++;
                        }
                    }
                }
                ly -= a;
            }
        }
        cout << ans << endl;
    } else {
        int ans=0;
        vector<vector<bool>> pole(N,vector<bool>(N,false));
        int sx=K,sy=K;
        for(int j=0;j<n;j++){
            string op;
            int a;
            op=opvec[j];
            a=k;
            if(op=="E"){
                for(int i=sx;i<=sx+a;i++){
                    if(!pole[sy][i]){
                        ans++;
                        pole[sy][i]=true;
                    }
                }
                sx+=a;
            }else if(op=="N"){
                for(int i=sy;i<=sy+a;i++){
                    if(!pole[i][sx]){
                        ans++;
                        pole[i][sx]=true;
                    }
                }
                sy+=a;
            }else if(op=="W"){
                for(int i=sx;i>=sx-a;i--){
                    if(!pole[sy][i]){
                        ans++;
                        pole[sy][i]=true;
                    }
                }
                sx-=a;
            }else if(op=="S"){
                for(int i=sy;i>=sy-a;i--){
                    if(!pole[i][sx]){
                        ans++;
                        pole[i][sx]=true;
                    }
                }
                sy-=a;
            }
        }
        cout<<ans<<endl;
    }
}